# Record Class CALocationPath

java.lang.Object
java.lang.Record
com.io7m.cardant.model.CALocationPath

Record Components:
  `path` - The path

public record CALocationPath(List<CALocationName> path) extends Record
The full path of a location.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CALocationPath(List<CALocationName> path)`
  The full path of a location.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `CALocationName`
  `last()`
  `static CALocationPath`
  `ofArray(String[] array)`
  Build a location path from the given array.
  `List<CALocationName>`
  `path()`
  Returns the value of the `path` record component.
  `static CALocationPath`
  `singleton(CALocationName name)`
  A singleton path.
  `static CALocationPath`
  `singleton(String name)`
  A singleton path.
  `String`
  `toString()`
  Returns a string representation of this record class.
  `CALocationPath`
  `withNewName(CALocationName name)`
  Replace the last path element with the given name.
  `CALocationPath`
  `withNewName(String name)`
  Replace the last path element with the given name.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CALocationPath

    public CALocationPath(List<CALocationName> path)
    The full path of a location.
    Parameters:
      `path` - The path

- ## Method Details

  - ### toString

    public String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### last

    public CALocationName last()
    Returns:
      The location name (the last path component)

  - ### withNewName

    public CALocationPath withNewName(CALocationName name)
    Replace the last path element with the given name.
    Parameters:
      `name` - The name
    Returns:
      The new path

  - ### withNewName

    public CALocationPath withNewName(String name)
    Replace the last path element with the given name.
    Parameters:
      `name` - The name
    Returns:
      The new path

  - ### ofArray

    public static CALocationPath ofArray(String[] array)
    Build a location path from the given array.
    Parameters:
      `array` - The array
    Returns:
      The path

  - ### singleton

    public static CALocationPath singleton(CALocationName name)
    A singleton path.
    Parameters:
      `name` - The name
    Returns:
      The path

  - ### singleton

    public static CALocationPath singleton(String name)
    A singleton path.
    Parameters:
      `name` - The name
    Returns:
      The path

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### path

    public List<CALocationName> path()
    Returns the value of the `path` record component.
    Returns:
      the value of the `path` record component